// =================================================================================
//	H2CTypes.h										 1998 NetFENCE Digital Ventures
// =================================================================================

#pragma once

#include <Files.h>

#pragma options align=mac68k

typedef enum {
	kST_None,
	kST_Public,
	kST_Protected,
	kST_Private
} H2CSectionT;

typedef struct {
	FSSpec			h2cFileHeaderSpec;
	FSSpec			h2cFileSourceSpec;
	FourCharCode	h2cFileSourceType;
	FourCharCode	h2cFileSourceCreator;
} H2CFilesT, *H2CFilesPtrT;

typedef struct {
	Str255	h2cClassName;
} H2CClassT, *H2CClassPtrT;

typedef struct {
	Str255		h2cMemberType;
	Boolean		h2cMemberIsStatic;
	short		h2cMemberPtrCount;
	Str255		h2cMemberName;
	H2CSectionT	h2cMemberSection;
} H2CMemberT, *H2CMemberPtrT;

typedef struct {
	Str255	h2cParamType; 
	Boolean	h2cParamIsTypeConst;
	short	h2cParamPtrCount;
	Boolean	h2cParamIsRef;
	Str255	h2cParamName;
	Boolean	h2cParamIsConst;
} H2CParamT;

typedef H2CParamT	H2CParamListT[];

typedef struct {
	Str255			h2cFuncName;
	Boolean			h2cFuncIsConstructor;
	Boolean			h2cFuncIsDestructor;
	H2CSectionT		h2cFuncSection;
	Str255			h2cFuncReturnType;
	short			h2cFuncReturnPtrCount;
	Boolean			h2cFuncReturnIsRef;
	Boolean			h2cFuncIsConst;
	Boolean			h2cFuncIsAbstract;
	Boolean			h2cFuncIsInlined;
	Boolean			h2cFuncIsPascal;
	Boolean			h2cFuncIsVirtual;
	Boolean			h2cFuncIsStatic;
	short			h2cFuncParamNum;
	H2CParamListT*	h2cFuncParams;
} H2CFunctionT, *H2CFunctionPtrT;

#pragma options align=reset