// =================================================================================
//	H2CModule.c										 1998 NetFENCE Digital Ventures
// =================================================================================

#include "H2CModule.h"

const Str255	kTitleLine = "\p// =================================================================================\n";
const Str255	kFunctionLine = "\p// ---------------------------------------------------------------------------------\n";
const Str255	kCommSingleTab = "\p//\t";
const Str255	kCommDoubleTabPoint = "\p//\t\t ";
const Str255	klnclude = "\p#include \"";
const Str255	kPragmaMarkStart = "\p#pragma mark  ";
const Str255	kPragmaMarkStop = "\p ";
const Str255	kEmptyFunction = "\p\n{\n}";
const Str255	kStatic = "\p [static]";
const Str255	kPascal = "\ppascal ";
const Str255	kScope = "\p::";
const Str255	kConst = "\pconst ";

const UInt8		char_Tab			 = 0x09;
const UInt8		char_Return			 = 0x0D;

Boolean gBeginFuncSerie = true;

// ---------------------------------------------------------------------------------
//		 H2C_Initialize
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_Initialize ()
{
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 H2C_Settings
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_Settings ()
{
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 H2C_Terminate
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_Terminate ()
{
	return noErr;
}

#pragma mark -

// ---------------------------------------------------------------------------------
//		 H2C_CheckFile
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_CheckFile (H2CFilesPtrT)
{
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 H2C_EnterFile
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_EnterFile (H2CCallbackPtrT callback, H2CFilesPtrT fi)
{	
	WritePString_ (kTitleLine);
	WritePString_ (kCommSingleTab);
	WritePString_ (fi->h2cFileSourceSpec.name);
	WriteChar_ (char_Return);
	WritePString_ (kTitleLine);
	WriteChar_ (char_Return);
	WritePString_ (klnclude);
	WritePString_ (fi->h2cFileHeaderSpec.name);
	WriteChar_ ('"');
	WriteChar_ (char_Return);
	
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 H2C_ExitFile
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_ExitFile (H2CCallbackPtrT, H2CFilesPtrT)
{
	return noErr;
}

#pragma mark -

// ---------------------------------------------------------------------------------
//		 H2C_EnterClass
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_EnterClass (H2CCallbackPtrT callback, H2CFilesPtrT, H2CClassPtrT ci)
{
	WriteChar_ (char_Return);
	WriteChar_ (char_Return);
	WritePString_ (kPragmaMarkStart);
	WritePString_ (ci->h2cClassName);
	WritePString_ (kPragmaMarkStop);
	gBeginFuncSerie = true;
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 H2C_ExitClass
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_ExitClass (H2CCallbackPtrT, H2CFilesPtrT, H2CClassPtrT)
{
	return noErr;
}

#pragma mark -

// ---------------------------------------------------------------------------------
//		 Member
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_Member (H2CCallbackPtrT callback, H2CFilesPtrT, H2CClassPtrT ci, H2CMemberPtrT mem)
{
	if (mem->h2cMemberIsStatic)
	{
		short i;
		
		WriteChar_ (char_Return);
		WritePString_ (mem->h2cMemberType);
		for (i = 1; i <= mem->h2cMemberPtrCount; i++) WriteChar_ ('*');
		WriteChar_ (' ');
		WritePString_ (ci->h2cClassName);
		WritePString_ (kScope);
		WritePString_ (mem->h2cMemberName);
		WriteChar_ (';');
	}
	return noErr;
}


// ---------------------------------------------------------------------------------
//		 Function
// ---------------------------------------------------------------------------------
pascal OSErr
H2C_Function (H2CCallbackPtrT callback, H2CFilesPtrT, H2CClassPtrT ci, H2CFunctionPtrT func)
{
	short i;
	
	if (func->h2cFuncIsAbstract) return noErr;
	
	if (!gBeginFuncSerie) WriteChar_ (char_Return);
	WriteChar_ (char_Return);
	WriteChar_ (char_Return);
	
	// Title.
	WritePString_ (kFunctionLine);
	WritePString_ (kCommDoubleTabPoint);
	WritePString_ (func->h2cFuncName);
	if (func->h2cFuncIsStatic) WritePString_ (kStatic);
	WriteChar_ (char_Return);
	WritePString_ (kFunctionLine);
	
	// Return type.
	if (!func->h2cFuncIsConstructor && !func->h2cFuncIsDestructor)
	{
		if (func->h2cFuncIsPascal) WritePString_ (kPascal);
		WritePString_ (func->h2cFuncReturnType);
		if (func->h2cFuncReturnIsRef) WriteChar_ ('&');
		for (i = 1; i <= func->h2cFuncReturnPtrCount; i++) WriteChar_ ('*');
		WriteChar_ (char_Return);
	}
	
	// Function name.
	WritePString_ (ci->h2cClassName);
	WritePString_ (kScope);
	WritePString_ (func->h2cFuncName);
	WritePString_ ("\p (");
	
	// Parameters.
	for (i = 0; i < func->h2cFuncParamNum; i++)
	{
		short j;
		
		if (func->h2cFuncParamNum >= 4)
			WritePString_ ("\p\n\t");
		if ((*func->h2cFuncParams)[i].h2cParamIsTypeConst) WritePString_ (kConst);
		WritePString_ ((*func->h2cFuncParams)[i].h2cParamType);
		for (j = 1; j <= (*func->h2cFuncParams)[i].h2cParamPtrCount; j++) WriteChar_ ('*');
		if (StrLength ((*func->h2cFuncParams)[i].h2cParamName) > 0)
		{
			WriteChar_ (' ');
			if ((*func->h2cFuncParams)[i].h2cParamIsConst) WritePString_ (kConst);
			if ((*func->h2cFuncParams)[i].h2cParamIsRef) WriteChar_ ('&');
			WritePString_ ((*func->h2cFuncParams)[i].h2cParamName);
		}
		else if ((*func->h2cFuncParams)[i].h2cParamIsRef) WriteChar_ ('&');

		if (i+1 != func->h2cFuncParamNum)
			WritePString_ ("\p, ");
	}
	
	WriteChar_ (')');
	WritePString_ (kEmptyFunction);
	gBeginFuncSerie = false;
	
	return noErr;
}